/* Copyright 1998 Sam Trenholme
   This program is released to the public domain. */

/* This program is automaticlly generated by make_scramble.c */

#include <sys/types.h>

u_int16_t sbox1[16] = { 0xf23c, 0xf43c, 0x19e2, 0x7b10, 
0x71cc, 0xf308, 0x15c5, 0xb559, 
0x2012, 0xa5c9, 0xf58c, 0xce19, 
0xc879, 0xc5c5, 0x6564, 0x02d3
}; 

u_int16_t sbox2[16] = { 0x4c23, 0xe828, 0x2a6a, 0xf7b2, 
0x53e7, 0x4563, 0x84b7, 0x280f, 
0x2170, 0x140f, 0x0127, 0x0531, 
0x0e82, 0x83d6, 0x8ea0, 0x840f
}; 

u_int16_t sbox3[16] = { 0x53b9, 0x5982, 0x91f9, 0x6a71, 
0x9286, 0xb1e9, 0xfafb, 0x0896, 
0x2f05, 0xbecd, 0x86a3, 0x7df4, 
0x52b6, 0x6431, 0x6120, 0x0689
}; 

u_int16_t sbox4[16] = { 0xdf67, 0x2909, 0x6acd, 0xfe59, 
0xe5ec, 0xca61, 0xb340, 0x0d49, 
0xff5c, 0x44c8, 0x0513, 0xcc83, 
0x29a7, 0xeaaa, 0x1d5b, 0xe4d2
}; 

#define f(x) ( ( ( sbox1[(x & 0xF000) >> 12] + sbox2[(x & 0x0F00) >> 8] )                  ^ sbox3[(x & 0x00F0) >> 4] ) + sbox4[x & 0x000F] )

u_int32_t scramble( u_int32_t plaintext ) 
{
u_int16_t l,r;
   
r = plaintext & 0xFFFF;
l = (plaintext >> 16) & 0xFFFF;

l ^= 0x84ef;
r ^= f(l) ^ 0x6c21;
l ^= f(r) ^ 0x9c34;
r ^= f(l) ^ 0x8e45;
l ^= f(r) ^ 0x28d4;
r ^= f(l) ^ 0x9a18;
l ^= f(r) ^ 0x011a;
r ^= f(l) ^ 0x1b27;
l ^= f(r) ^ 0x5d5f;
r ^= f(l) ^ 0xab21;
l ^= f(r) ^ 0xaf84;
r ^= f(l) ^ 0xcece;
l ^= f(r) ^ 0x73c8;
r ^= f(l) ^ 0x4441;
l ^= f(r) ^ 0xadc3;
r ^= f(l) ^ 0x3b09;
l ^= f(r) ^ 0xc472;
r ^= 0xc786;

return ((r << 16) | (l & 0xFFFF));

}

u_int32_t unscramble( u_int32_t plaintext ) 
{
u_int16_t l,r;
   
l = plaintext & 0xFFFF;
r = (plaintext >> 16) & 0xFFFF;

r ^= 0xc786;
l ^= f(r) ^ 0xc472;
r ^= f(l) ^ 0x3b09;
l ^= f(r) ^ 0xadc3;
r ^= f(l) ^ 0x4441;
l ^= f(r) ^ 0x73c8;
r ^= f(l) ^ 0xcece;
l ^= f(r) ^ 0xaf84;
r ^= f(l) ^ 0xab21;
l ^= f(r) ^ 0x5d5f;
r ^= f(l) ^ 0x1b27;
l ^= f(r) ^ 0x011a;
r ^= f(l) ^ 0x9a18;
l ^= f(r) ^ 0x28d4;
r ^= f(l) ^ 0x8e45;
l ^= f(r) ^ 0x9c34;
r ^= f(l) ^ 0x6c21;
l ^= 0x84ef;

return ((l << 16) | (r & 0xFFFF));

}
